package com.fp.persistence.pgeneral.gene;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Table;

import com.fp.dto.hb.Cache;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENEPARAMETERS*/
@Entity(name="TgeneParameters")
@Table(name="TGENEPARAMETERS")
public class TgeneParameters extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable,Cache{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneParameters
*/
@EmbeddedId
private TgeneParametersKey pk;
@Column(name="TEXTVALUE", nullable=true)

/**
* Valor texto del parametro.
*/
private String textvalue;

@Column(name="NUMBERVALUE", nullable=true)

/**
* Valor numero del parametro.
*/
private BigDecimal numbervalue;

@Column(name="DESCRIPTION", nullable=true)

/**
* Descripcion del parametro
*/
private String description;

/**Contructor por defecto*/
public TgeneParameters(){
}
/**Contructor de TgeneParameters
@param pPk Clave Primaria del entity
*/
public TgeneParameters(TgeneParametersKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneParameters
*/
public static TgeneParameters find(EntityManager pEntityManager,TgeneParametersKey pKey) throws Exception{
    TgeneParameters obj = pEntityManager.find(TgeneParameters.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneParameters
@return El objeto que referencia a la Clave primaria de TgeneParameters
*/
public TgeneParametersKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneParameters
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneParameters
*/
public void setPk(TgeneParametersKey pPk){
  pk=pPk;
}
/**Obtiene el valor de textvalue
@return valor de textvalue*/
public String getTextvalue(){
  return textvalue;
}
/**Fija el valor de textvalue
@param pTextvalue nuevo Valor de textvalue*/
public void setTextvalue(String pTextvalue){
  textvalue=pTextvalue;
}

/**Obtiene el valor de numbervalue
@return valor de numbervalue*/
public BigDecimal getNumbervalue(){
  return numbervalue;
}
/**Fija el valor de numbervalue
@param pNumbervalue nuevo Valor de numbervalue*/
public void setNumbervalue(BigDecimal pNumbervalue){
  numbervalue=pNumbervalue;
}

/**Obtiene el valor de description
@return valor de description*/
public String getDescription(){
  return description;
}
/**Fija el valor de description
@param pDescription nuevo Valor de description*/
public void setDescription(String pDescription){
  description=pDescription;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneParameters))return false;
    TgeneParameters that = (TgeneParameters) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneParameters
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneParameters
*/
public Object createInstance(){
 TgeneParameters instance=new TgeneParameters();	
 instance.setPk(new TgeneParametersKey());
 return instance;
}
/**Clona la entidad TgeneParameters
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneParameters p=(TgeneParameters)this.clone();
  p.setPk((TgeneParametersKey)this.pk.cloneMe());
  return p;
}
}
